#!/usr/bin/perl

use IO::Socket;
use Getopt::Long;

GetOptions( 	"help"		=> \$help,
		"shadow=s"	=> \$shadow,
		"port=s"	=> \$port,
		"ip=s"		=> \$host,
		"bcrypt=s"	=> \$bcrypt,
	 );

if ($help) {
	print STDOUT "USAGE: $0 --help --shadow --port --ip\n";
	print STDOUT "\t where shadow is file to store shadow file\n";
	print STDOUT "\t\t eg: /home/kurt/crack/shadow.txt\n";
	print STDOUT "\t where port is BIND_PORT\n";
	print STDOUT "\t where ip is BIND_IP\n";	
	print STDOUT "\t where bcrypt is path ot bcrypt\n";	
	exit 0;		
}

die "no port given: use $0 --help" unless defined $port;
die "no ip given use $0 --help" unless defined $host;

#$shadow_ready_serv = "$shadow.bfe | uuencode $shadow.bfe >> $shadow.serv";
$bc_standart="/usr/local/bin/bcrypt";

&start_client;
sub start_client {

our $client = IO::Socket::INET->new(PeerAddr => $host,
				PeerPort 	=> $port,
				Type 		=> SOCK_STREAM,
				Proto		=> "tcp")
 	or die "$! :can't establish connection on $host Port $port\n";
print "Client [Host:$host Port:$port] is online!\n";

@content=<$client>;
#print "i got something:@content\a\n";
}

open(SHADOW,"+>$shadow.bfe.uue") or die "not possible:$!\n";
print SHADOW @content;
close SHADOW or warn "no close on SHADOW:$!\n";

if ($bcrypt) {
	$shadow_ready_client = "$shadow.bfe.uue | uudecode -o $shadow.bfe $shadow.bfe.uue";
	system("cat $shadow_ready_client");
	system("$bcrypt $shadow.bfe");
		
} else {
	print "no bcrypt directory given - trying default \n";
	$info = stat($bc_standart) or die "$bc_standart not found!\n";
	$shadow_ready_client = "$shadow.bfe.uue | uudecode -o $shadow.bfe $shadow.bfe.uue";
	system("cat $shadow_ready_client");
	system("$bc_standart $shadow.bfe");
	print "sucessful!\n";
	
}

