/*
 * This file is part of Distributed John,
 * Copyright (C) 2001-2003 by Luis Parravicini
 * http://ktulu.com.ar
 */
#include <sys/types.h>
#include <netinet/in.h>

#include "defs.h"

#define ERR_SENDING	-1
#define ERR_RECVING	-2
#define ERR_LESS	-3
#define ERR_LESS2	-4
#define ERR_TIMEOUT	-5
#define ERR_CONSISTENCY	-6

extern const char *err_list[];
extern int erridx;

#define qerror(s) fprintf(stderr, "%s: %s\n", gettext(err_list[-erridx]), s)

/*
 * Debian 2.2r3 and Mandrake 7.0 doesn't have this type defined, uncomment the
 * line with the typedef if you get errors compiling.
 */
/* typedef uint16_t in_port_t; */

int mkserver(struct in_addr *, in_port_t);
int sendmessage(int, struct generic_packet *, const struct sockaddr_in *,
		void *, int, int);
int send_to_client(int, struct generic_packet*, const struct sockaddr_in*);
int read_message(int, void *, int, struct sockaddr_in*);

