/*
 * This file is part of Distributed John,
 * Copyright (C) 2001-2003 by Luis Parravicini
 * http://ktulu.com.ar
 */
#ifndef __WORD_H
#define __WORD_H

#include <inttypes.h>

/* errores devueltos por strtoword */
#define INVALID_CHAR	1
#define	STR_TOO_LONG	2
#define NULL_STR	3

/* longitud maxima de una palabra a probar por John */
#define MAX_WORD  15

/* cada elemento de data es un indice a charset */
/* FIXME: hacer una clase o sobrecargar los operadores =,==,> */
struct word {
	uint8_t length		__attribute__ ((packed));
	uint8_t data[MAX_WORD]	__attribute__ ((packed));
};
#define WORD_SIZE(x) (sizeof(uint8_t) + MAX_WORD * sizeof(uint8_t))
/*			((struct word*)x)->length * sizeof(uint8_t)) */

unsigned char *charset;
int charsetl;
int mkcharset(unsigned char *);
int strtoword(char *, struct word *);
int wordcmp(struct word, struct word);
char* wordtostr(struct word *, char *);
int wordlen(struct word *);
void show_error(int, char *);

#endif
